/***************************************************************************
 *   Copyright (C) 2007 by GNB	(Grupo Computacion Biologica), EPS (Madrid)*
 *   Carlos Muñiz Solaz							   * 
 *   carlos.muniz@uam.es   						   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/* LogFile.cpp */
#include "LogFile.h"
#define MAX_LINE_LENGTH 1500

extern int cmdFifo;

LogFile::LogFile(const QString& filename)
{
//  shm = Shm::Instance();
//  assert ( shm != 0);
    setName(filename);

    dataFile=NULL;
}

LogFile::LogFile()
{
//   shm = Shm::Instance();
//  assert ( shm != 0 );

    dataFile=NULL;
}

void LogFile::open()
{
    if (fname.isEmpty()) return;

    // open file
    dataFile = new QFile(fname);

    dataFile->open(IO_Raw | IO_ReadWrite | IO_Append );
    writeOrnamentCommentToFile();
    writeStringToFile(" Motor logging file ");
    return;
}//

void LogFile::close()
{
    if (!dataFile)
        dataFile->close();
}// End close


LogFile::~LogFile()
{
    close();
}

void LogFile::setName(const QString& filename)
{
    // assign file name
    fname = filename;
}

void LogFile::writeDate()
{
    int a = QString::compare(fname, "Motor_position.txt");
    if ( a == 0)
    {
//		QString s = QString::number(shm->getTime()*0.001);
        //	dataFile->writeBlock( s +" ", s.length() + 1);
    }
    else
    {
        QDateTime date = QDateTime::currentDateTime();
        QString s = date.toString("[dd.MM.yyyy hh:mm:ss.zzz] ");
//		s += QString::number(shm->getTime()*0.001);
        dataFile->writeBlock( s + " ", s.length() + 1);
    }
}

void LogFile::writeHour()
{
    QTime time;
    QDateTime date;
    date = QDateTime::currentDateTime();
    time = date.time();
    QString s = date.toString("[hh:mm:ss.zzz] ");
    dataFile->writeBlock(s, s.length() + 1);
}

void LogFile::writeEntryToFile(const QString& key, const QString& value)
{
    writeDate();
    dataFile->writeBlock(key + " = " + value + "\n",
                         key.length() + 3 + value.length() + 1);


}

void LogFile::writeEntryToFile(const QString& key, int value)
{
    if (!dataFile) return;

    dataFile->writeBlock(key + " = " + QString::number(value) ,
                         key.length() + 3 + QString::number(value).length() + 1);

}

void LogFile::writeEntryToFile(const QString& key, double value)
{
    if (!dataFile) return;
    writeDate();
    dataFile->writeBlock(key + " = " + QString::number(value) + "\n" ,
                         key.length() + 3 + QString::number(value).length() + 1);
}

void LogFile::writeStringToFile(const QString& string)
{
    if (!dataFile) return;
    writeDate();
    dataFile->writeBlock(string + "\n",
                         string.length() + 1);
}

void LogFile::writeCommentToFile(const QString& string)
{
    if (!dataFile) return;

    dataFile->writeBlock("#-- "+string + "\n",
                         4+string.length() + 1);
}

void LogFile::writeOrnamentCommentToFile()
{
    if (!dataFile) return;

    QString tmp="#----------------------------------------------------------------#\n";

    dataFile->writeBlock(tmp, tmp.length());
}

void LogFile::addLine()
{
    if (!dataFile) return;

    QString tmp="\n";

    dataFile->writeBlock(tmp, tmp.length());
}

void LogFile::getUser()
{
    /*	//user = new QUuid();
    owner = new QFileInfo;
    uint u;
    u = owner->ownerId ();
    QString name;
    name = QString::number(u);
        dataFile->writeBlock(name, name.length());*/

}
