/***************************************************************************
 *   Copyright (C) 2007 by GNB	(Grupo Computacion Biologica), EPS (Madrid)*
 *   Carlos Muñiz Solaz							   * 
 *   carlos.muniz@uam.es   						   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/* LogFile.h */

#ifndef LOGFILE_H
#define LOGFILE_H

// qt include
#include <qstring.h>
#include <qmap.h>
#include <qstringlist.h>
#include <qfile.h>
#include <qregexp.h>
#include <qvaluevector.h>
#include <qdatetime.h>
#include <quuid.h>

#include <iostream>
using namespace std;
#include <fstream>


#include <qfileinfo.h>

class LogFile
{
public:
    LogFile();
    LogFile(const QString& filename);
    ~LogFile();
    void open();
    void close();

    // file
    void setName(const QString& filename);
    const QString& name() const
    {
        return fname;
    }

    void writeDate();
    void writeHour();
    void writeEntryToFile(const QString& key, const QString& value);
    void writeEntryToFile(const QString& key, int value);
    void writeEntryToFile(const QString& key, double value);
    void writeCommentToFile(const QString& string);
    void writeOrnamentCommentToFile();
    void writeStringToFile(const QString& string);
    void addLine();
    void getUser();

private:
    QFile *dataFile;
    QDateTime* date;
    QString fname;
    // QFileInfo* owner;
//QUuid* user;
};

#endif
