/***************************************************************************
 *   Copyright (C) 2007 by GNB	(Grupo Computacion Biologica), EPS (Madrid)*
 *   Carlos Muñiz Solaz							   * 
 *   carlos.muniz@uam.es   						   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/****************************************************************************
** Form implementation generated from reading ui file 'motorcontrol.ui'
**
** Created: lun jul 17 16:40:45 2006
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.1.2   edited Dec 19 11:45 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "MotorControl.h"
#include "CConfigFile.h"

#include <qapplication.h>

#include <qvariant.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qtimer.h>
#include <qwt_slider.h>
#include <assert.h>
#include <qvalidator.h>
#include <qerrormessage.h>
#include <qdatetime.h>
#include <qdatastream.h>
#include <qfile.h>
#include <fstream>
#include <stdio.h>
#include <sys/time.h>
#include <time.h>
#include <unistd.h>
//#include "floatspinbox.h"
#include <qbuttongroup.h>
#include <qlabel.h>
#include <qcheckbox.h>
#include <qlayout.h>

#include <iostream>
using namespace std;

/*
 *  Constructs a MotorControl as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
MotorControl::MotorControl( QWidget* parent, const char* name, bool modal, WFlags fl )
        : QDialog( parent, name, modal, fl )
{
    if ( !name )
        setName( "MotorControl" );
    setEnabled( TRUE );

    shmMotor = ShmMotor::Instance();
    assert ( shmMotor != 0);

    periodicBG = new QButtonGroup( this, "periodicBG" );
    periodicBG->setGeometry( QRect( 10, 240, 271, 90 ) );

    timeLabel = new QLabel( periodicBG, "timeLabel" );
    timeLabel->setGeometry( QRect( 10, 30, 67, 20 ) );

    periodicButton = new QPushButton( periodicBG, "periodicButton" );
    periodicButton->setGeometry( QRect( 180, 30, 70, 20 ) );

    foreverLabel = new QLabel( periodicBG, "foreverLabel" );
    foreverLabel->setGeometry( QRect( 30, 60, 81, 21 ) );

    foreverBox = new QCheckBox( periodicBG, "foreverBox" );
    foreverBox->setGeometry( QRect( 10, 60, 20, 20 ) );

    periodLineEdit = new QLineEdit( periodicBG, "periodLineEdit" );
    periodLineEdit->setGeometry( QRect( 80, 30, 90, 23 ) );

    leftButton = new QPushButton( this, "leftButton" );
    leftButton->setGeometry( QRect( 90, 340, 101, 51 ) );

    rightButton = new QPushButton( this, "rightButton" );
    rightButton->setGeometry( QRect( 230, 340, 100, 50 ) );

    stopButton = new QPushButton( this, "stopButton" );
    stopButton->setGeometry( QRect( 160, 400, 110, 31 ) );
    stopButton->setPaletteForegroundColor( QColor( 0, 0, 0 ) );

    calibrateButton = new QPushButton( this, "calibrateButton" );
    calibrateButton->setGeometry( QRect( 270, 460, 70, 20 ) );

    rewindButton = new QPushButton( this, "rewindButton" );
    rewindButton->setGeometry( QRect( 200, 460, 70, 20 ) );

    closeButton = new QPushButton( this, "closeButton" );
    closeButton->setGeometry( QRect( 190, 510, 90, 30 ) );

    currPosLabel = new QLabel( this, "currPosLabel" );
    currPosLabel->setGeometry( QRect( 70, 460, 67, 20 ) );

    settingsBG = new QButtonGroup( this, "settingsBG" );
    settingsBG->setGeometry( QRect( 10, 20, 280, 210 ) );

    incModeLabel = new QLabel( settingsBG, "incModeLabel" );
    incModeLabel->setGeometry( QRect( 30, 160, 121, 21 ) );

    incModeBox = new QCheckBox( settingsBG, "incModeBox" );
    incModeBox->setGeometry( QRect( 10, 160, 20, 20 ) );

    timeRevlineEdit = new QLineEdit( settingsBG, "timeRevlineEdit" );
    timeRevlineEdit->setGeometry( QRect( 211, 31, 58, 23 ) );

    trLabel = new QLabel( settingsBG, "trLabel" );
    trLabel->setGeometry( QRect( 165, 31, 40, 21 ) );

    maxRightEL = new QLineEdit( settingsBG, "maxRightEL" );
    maxRightEL->setEnabled( FALSE );
    maxRightEL->setGeometry( QRect( 211, 60, 58, 23 ) );
    maxRightEL->setAlignment( int( QLineEdit::AlignAuto ) );

    maxLeftLE = new QLineEdit( settingsBG, "maxLeftLE" );
    maxLeftLE->setEnabled( FALSE );
    maxLeftLE->setGeometry( QRect( 211, 89, 58, 23 ) );
    maxLeftLE->setAlignment( int( QLineEdit::AlignAuto ) );

    maxRangleLabel = new QLabel( settingsBG, "maxRangleLabel" );
    maxRangleLabel->setGeometry( QRect( 165, 61, 40, 21 ) );

    maxLangleLabel = new QLabel( settingsBG, "maxLangleLabel" );
    maxLangleLabel->setGeometry( QRect( 165, 88, 40, 21 ) );

    speedLineEdit = new QLineEdit( settingsBG, "speedLineEdit" );
    speedLineEdit->setGeometry( QRect( 95, 32, 53, 23 ) );
    speedLineEdit->setAlignment( int( QLineEdit::AlignAuto ) );

    rightEditLine = new QLineEdit( settingsBG, "rightEditLine" );
    rightEditLine->setGeometry( QRect( 95, 61, 53, 23 ) );
    rightEditLine->setAlignment( int( QLineEdit::AlignAuto ) );

    leftEditLine = new QLineEdit( settingsBG, "leftEditLine" );
    leftEditLine->setGeometry( QRect( 95, 90, 53, 23 ) );
    leftEditLine->setAlignment( int( QLineEdit::AlignAuto ) );

    angleIncLE = new QLineEdit( settingsBG, "angleIncLE" );
    angleIncLE->setEnabled( FALSE );
    angleIncLE->setGeometry( QRect( 95, 119, 53, 23 ) );

    speedLabel = new QLabel( settingsBG, "speedLabel" );
    speedLabel->setGeometry( QRect( 12, 32, 75, 23 ) );

    rightAngleLabel = new QLabel( settingsBG, "rightAngleLabel" );
    rightAngleLabel->setGeometry( QRect( 12, 61, 75, 23 ) );

    leftAngleLabel = new QLabel( settingsBG, "leftAngleLabel" );
    leftAngleLabel->setGeometry( QRect( 12, 90, 75, 23 ) );

    angleIncrementLabel = new QLabel( settingsBG, "angleIncrementLabel" );
    angleIncrementLabel->setGeometry( QRect( 12, 119, 75, 23 ) );

    currPosLineEdit = new QLineEdit( this, "currPosLineEdit" );
    currPosLineEdit->setEnabled( FALSE );
    currPosLineEdit->setGeometry( QRect( 140, 460, 50, 23 ) );

    extraSettingBG = new QButtonGroup( this, "extraSettingBG" );
    extraSettingBG->setGeometry( QRect( 300, 20, 145, 140 ) );

    loadDefButton = new QPushButton( extraSettingBG, "loadDefButton" );
    loadDefButton->setGeometry( QRect( 15, 20, 110, 32 ) );

    saveDefButton = new QPushButton( extraSettingBG, "saveDefButton" );
    saveDefButton->setGeometry( QRect( 15, 55, 110, 32 ) );

    loadScripButton = new QPushButton( extraSettingBG, "loadScripButton" );
    loadScripButton->setGeometry( QRect( 15, 90, 110, 32 ) );

    accelBG = new QButtonGroup(  this, "accelBG" );
    accelBG->setGeometry( QRect( 300, 165, 145, 165 ) );

    accelButton = new QPushButton( this, "accelButton");
    accelButton->setGeometry( QRect ( 335, 265, 80, 23 ));

    accelLE = new QLineEdit( this, "accelLE");
    accelLE->setGeometry( QRect (370, 185, 50, 23));

    accelLabel = new QLabel(this, "accelLabal");
    accelLabel->setGeometry( QRect(310, 185, 50, 23) );

    timeAccelLE = new QLineEdit( this, "timeAccelLE");
    timeAccelLE->setGeometry( QRect (370, 215, 50, 23));

    timeAccelLabel = new QLabel(this, "timeAccelLabel");
    timeAccelLabel->setGeometry( QRect(310, 215, 50, 23) );

    rightBox = new QCheckBox( this, "rightBox" );
    rightBox->setGeometry( QRect( 310, 240, 20, 20 ) );

    rightLabel = new QLabel( this, "rightLabel" );
    rightLabel->setGeometry( QRect( 330, 240, 51, 21 ) );

    leftBox = new QCheckBox( this, "leftBox" );
    leftBox->setGeometry( QRect( 370, 240, 20, 20 ) );

    leftLabel = new QLabel( this, "leftLabel" );
    leftLabel->setGeometry( QRect( 390, 240, 41, 21 ) );

    currSpeedLineEdit = new QLineEdit( this, "currSpeedLineEdit" );
    currSpeedLineEdit->setEnabled( FALSE );
    currSpeedLineEdit->setGeometry( QRect( 335, 300, 80, 23 ) );

    languageChange();
    resize( QSize(450, 570).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    ErrorMessage = new QErrorMessage ( this, "Error Message" );

    /*
    */
    //double max_right_angle = maxRightEL->text().toDouble();
    //  rightValidator = new QDoubleValidator ( 0, max_right_angle, 0, this, "rightValidator" );

    //double min_left_angle = maxLeftLE->text().toDouble();
    //  leftValidator = new QDoubleValidator ( min_left_angle, 0, 0, this, "leftValidator" );

    // speedValidator = new QDoubleValidator ( MIN_SPEED, MAX_SPEED, 0, this, "speedValidator" );

    QDateTime date = QDateTime::currentDateTime();
    QString s = "log/motor_";  
    s += date.toString("dd.MM.yyyy") + "_" + date.toString("hh:mm:ss.zzz");

    file = new LogFile(s);
    file->open();

    file1 = new LogFile("log/Motor_position.txt");
    file1->open();
    /*   double speed = speedLineEdit->text().toDouble();
       double right_angle = rightEditLine->text().toDouble();
       double left_angle = leftEditLine->text().toDouble();
       file->writeEntryToFile(" Right angle ", right_angle);
       file->writeEntryToFile(" Left angle ", left_angle);
       file->writeEntryToFile(" Speed ", speed);*/

    timer = new QTimer();
    // timer->start (100); //en febe
    timer->start (233); //en ceres
    timer1 = new QTimer();
    timer1->start (233);

    // signals and slots connections
    connect (timer, SIGNAL (timeout()), this, SLOT (updatePosition()));
    connect( closeButton, SIGNAL( clicked() ), this, SLOT( close ()) );
    connect( speedLineEdit, SIGNAL( returnPressed() ), this, SLOT( updateSpeed() ) );
    connect( rightEditLine, SIGNAL( returnPressed() ), this, SLOT( updateRangle() ) );
    connect( leftEditLine, SIGNAL( returnPressed() ), this, SLOT( updateLangle() ) );
    connect( calibrateButton , SIGNAL( clicked() ), this, SLOT( motorCalibrate() ) );
    connect( leftButton, SIGNAL( clicked() ), this, SLOT( moveLeft () ) );
    connect( rightButton, SIGNAL( clicked() ), this, SLOT( moveRight () ) );
    connect( stopButton, SIGNAL( clicked() ), this, SLOT( motorStop() ) );
    connect( loadDefButton, SIGNAL( pressed() ), this, SLOT( loadDefaults ()));
    connect( rewindButton , SIGNAL( clicked() ), this, SLOT( rewind()) );
    connect( periodicButton, SIGNAL( pressed()), this, SLOT( periodic() ));
    connect( periodLineEdit, SIGNAL( returnPressed() ), this, SLOT( updatePeriod() ));
    connect( incModeBox, SIGNAL( pressed() ), this, SLOT( incremental() ) );
    connect( saveDefButton, SIGNAL( clicked() ), this, SLOT ( saveDef() ));

    connect( accelLE, SIGNAL( returnPressed() ), this, SLOT( updateAccel() ) );
    connect( timeAccelLE, SIGNAL( returnPressed() ), this, SLOT( updateTime_accel() ) );
    connect( accelButton, SIGNAL( pressed() ), this, SLOT( accelerate() ) );
    connect (timer1, SIGNAL (timeout()), this, SLOT (updateAspeed()));

    init();

}

bool MotorControl::init ()
{
    // Load default values
    //  loadDefaults();
    return true;
}

/*
 *  Destroys the object and frees any allocated resources
 */
MotorControl::~MotorControl()
{
    // no need to delete child widgets, Qt does it all for us
    /**
      if ( timer )
     {
        timer->stop();
     	delete timer;
     }
    **/

    //  if ( !shmMotor )
    delete shmMotor;
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void MotorControl::languageChange()
{
    setCaption( tr( "Motor Control" ) );
    settingsBG->setTitle( tr( "Settings" ) );
    incModeLabel->setText( tr( "Incremental Mode" ) );
    incModeBox->setText( tr( "incModeBox" ) );
    maxRightEL->setText( trUtf8( "45" ) );
    maxLeftLE->setText( trUtf8( "45" ) );
    maxRangleLabel->setText( tr( " Max" ) );
    maxLangleLabel->setText( tr( " Max" ) );
    speedLabel->setText( trUtf8( "Speed (º/s):" ) );
    rightAngleLabel->setText( tr( "Right Angle:" ) );
    leftAngleLabel->setText( tr( "Left Angle:" ) );
    angleIncrementLabel->setText( tr( "Angle Inc:" ) );
    trLabel->setText( tr("tr (s)") );
    speedLineEdit->setText( tr( "20" ) );
    rightEditLine->setText( tr( "10" ) );
    leftEditLine->setText( tr( "10" ) );
    angleIncLE->setText( trUtf8( "0.15º" ) );
    extraSettingBG->setTitle( tr( "Extra Settings" ) );
    loadDefButton->setText( tr( "Load Def." ) );
    saveDefButton->setText( tr( "Save Def." ) );
    loadScripButton->setText( tr( "Load Script" ) );
    periodicBG->setTitle( tr( "Periodic Mode" ) );
    timeLabel->setText( tr( "Time (ms):" ) );
    periodicButton->setText( tr( "Periodic" ) );
    foreverLabel->setText( tr( "Forever" ) );
    foreverBox->setText( tr( "foreverBox" ) );
    leftButton->setText( tr( "<-" ) );
    rightButton->setText( tr( "->" ) );
    stopButton->setText( tr( "Stop" ) );
    currPosLabel->setText( tr( "Curr. Pos.:" ) );
    currPosLineEdit->setText( trUtf8( "0º" ) );
    rewindButton->setText( tr( "Rewind" ) );
    calibrateButton->setText( tr( "Zeroing" ) );
    closeButton->setText( tr( "Close" ) );
    timeRevlineEdit->setText( tr("18") );
    periodLineEdit->setText( tr( "5000" ));
    accelButton->setText( tr( "Accelerate" ) );
    accelLE->setText( tr ("1") );
    accelLabel->setText( tr ("Accel:") );
    timeAccelLE->setText( tr ("1000") );
    timeAccelLabel->setText( tr ("Ta (ms):") );
    accelBG->setTitle( tr ("Accelerate") );
    rightLabel->setText( tr("Right"));
    leftLabel->setText( tr("Left"));
}

void MotorControl::updateSpeed ()
{
    bool b;
    double speed = speedLineEdit->text().toDouble(&b);

    bool a = validateSpeed();

    if (b == FALSE)
    {
        speedLineEdit->setText( tr( QString::number(speed) ) );
        shmMotor->changeSpeed(speed);
    }

    if ( a == TRUE)
    {
        shmMotor->changeSpeed(speed);
        cout << "Speed updated to = " << speed << endl;
        file->writeEntryToFile(" Speed ", speed);
    }
    else
    {
        speed = 20;
        speedLineEdit->setText( tr( "20" ) );
        shmMotor->changeSpeed(20);
        file->writeStringToFile(" Speed value invalid");
        file->writeEntryToFile(" Speed updated to", speed);
        double time_rev = 360.0/speed;
        QString s = QString::number(time_rev);
        timeRevlineEdit->setText( tr( s ) );

    }

    double time_rev = 360.0/speed;
    QString s = QString::number(time_rev);
    timeRevlineEdit->setText( tr( s ) );
}

void MotorControl::updateRangle ()
{
    cout << "MotorControl::updateRangle ()" << endl;
    bool b;
    double right_angle = rightEditLine->text().toDouble(&b);
    cout << "Right angle updated to = " << right_angle << endl;
    bool a = validateRight();
    if (b == FALSE)
    {
        rightEditLine->setText( tr( QString::number(right_angle) ) );
        shmMotor->setRangle (right_angle);
    }
    if (a == TRUE)
    {
        shmMotor->setRangle (right_angle);
        file->writeEntryToFile(" Right angle updated to", right_angle);
        cout << "Right angle updated to = " << right_angle << endl;
    }
    else
    {
        rightEditLine->setText( tr( "10" ) );
        shmMotor->setRangle (10);
        file->writeStringToFile(" Right angle invalid");
        file->writeEntryToFile(" Right angle ", right_angle);
    }
}

void MotorControl::updateLangle ()
{
    bool b;
    double left_angle = leftEditLine->text().toDouble(&b);
    cout << "Left angle updated to = " << left_angle << endl;
    bool a = validateLeft();
    if (b == FALSE)
    {
        leftEditLine->setText( tr( QString::number(left_angle) ) );
        shmMotor->setRangle (left_angle);
    }
    if ( a == TRUE )
    {
        shmMotor->setLangle (left_angle);
        file->writeEntryToFile(" Left angle updated to", left_angle);
        cout << "Left angle updated to = " << left_angle << endl;
    }
    else
    {
        leftEditLine->setText( tr( "10" ) );
        shmMotor->setLangle (10);
        file->writeStringToFile(" Left angle invalid");
        file->writeEntryToFile(" Left angle ", left_angle);
    }
}

void MotorControl::updatePeriod ()
{
    double period = periodLineEdit->text().toDouble();
    cout << "period updated to = " << period << endl;
    shmMotor->setPeriod (period);
    //file->writeEntryToFile(" Period updated to", period);
}

void MotorControl::updateAccel()
{
    double accel = accelLE->text().toDouble();
    cout << "acceleration updated to = " << accel << endl;
    shmMotor->setAcceleration (accel);
    file->writeEntryToFile(" Acceleration updated to", accel);
}

void MotorControl::updateTime_accel()
{
    double time_accel = timeAccelLE->text().toDouble();
    cout << "acceleration updated to = " << time_accel << endl;
    shmMotor->setAcceleration (time_accel);
    file->writeEntryToFile(" Acceleration time ", time_accel);
}

void MotorControl::motorCalibrate ()
{
    shmMotor->calibrate();

    file->writeStringToFile("Motor calibrated ");
}

void MotorControl::moveLeft()
{
    double left_angle = leftEditLine->text().toDouble();
    //double speed = speedLineEdit->text().toDouble();

    double position;
    position = shmMotor->getPosition ();

    cout << "MotorControl::moveLeft(" << left_angle << " )" << endl;

    shmMotor->moveLeft (left_angle);

    if ( incModeBox->isChecked() == TRUE)
    {
        file->writeEntryToFile( "Motor position", position);
        file->writeStringToFile(" Motor moved left from 0.15º ");

    }
    else
    {
        file->writeStringToFile("Motor moved left");
        file->writeEntryToFile( "Motor position", position);
        file->writeEntryToFile("Left angle ", left_angle/*shmMotor->getLangle()*/);
    }
}

void MotorControl::moveRight()
{
    double right_angle = rightEditLine->text().toDouble();
//	double speed = speedLineEdit->text().toDouble();
    cout << "MotorControl::moveRight(" << right_angle << ")" << endl;

    double position;
    position = shmMotor->getPosition ();

    shmMotor->moveRight (right_angle);


    if ( incModeBox->isChecked() == TRUE)
    {
        file->writeEntryToFile( "Motor position", position);
        file->writeStringToFile(" Motor moved right from 0.15º ");

    }
    else
    {
        file->writeStringToFile("Motor moved right");
        file->writeEntryToFile( "Motor position", position);
        file->writeEntryToFile("Right angle ", right_angle/*shmMotor->getRangle()*/);
    }
}

void MotorControl::updatePosition()
{
    double position;
    position = shmMotor->getPosition ();
    if (position < 0.14 && position > -0.14)
    {
	position = 0.0;
    }
    QString s = QString::number(position, 'g', 4);

    currPosLineEdit->setText( tr(s) );
    file1->writeEntryToFile("Position ",position);

}

void MotorControl::updateAspeed()
{
    double speed;
    speed = shmMotor->getSpeed ();
    QString s = QString::number(speed);
    currSpeedLineEdit->setText( tr(s) );
    //speedLineEdit->setText( tr(s) );
}

void MotorControl::motorStop()
{
    shmMotor->stopMotor();

    double position;
    position = shmMotor->getPosition ();
    file->writeEntryToFile( "Motor position when stopped", position);
    file->writeStringToFile("Motor stopped ");
}


bool MotorControl::validateRight ()
{
    bool a;
    double max_right_angle = maxRightEL->text().toDouble(&a);
    double right_angle = rightEditLine->text().toDouble(&a);

    QDoubleValidator rightValidator( 0, max_right_angle, 0, this, "rightValidator");
    rightEditLine->setValidator(&rightValidator);
    if ( (right_angle < 0) || (right_angle > max_right_angle))
    {
        ErrorMessage->message("Right Angle value incorrect\nEnter a value between 0 and 50");
        return FALSE;
    }
    else
        return TRUE;

}

bool MotorControl::validateLeft ()
{

    bool a;
    double min_left_angle = maxLeftLE->text().toDouble(&a);
    double left_angle = leftEditLine->text().toDouble(&a);

    QDoubleValidator leftValidator( min_left_angle, 0, 0, this, "leftValidator" );
    leftEditLine->setValidator(&leftValidator);
    if ( (left_angle < 0) || (left_angle > min_left_angle))
    {
        ErrorMessage->message("Left Angle value incorrect\nEnter a value between 0 and 50");
        return FALSE;
    }
    else
        return TRUE;

}

bool MotorControl::validateSpeed ()
{

    bool a;
    double speed = speedLineEdit->text().toDouble(&a);

    QDoubleValidator speedValidator( MIN_SPEED, MAX_SPEED, 0, this, "speedValidator" );
    speedLineEdit->setValidator(&speedValidator);
    if ( ( speed > MAX_SPEED ) || (speed < MIN_SPEED) )
    {
        ErrorMessage->message("Speed value incorrect\nEnter a value between 30 and 0.072");
        return FALSE;
    }
    else
        return TRUE;
}

void MotorControl::loadDefaults()
{
    CConfigFile cf ("motor.cfg");


    cf.read();

    // Read file
    cf.setGroup ("General");

    QString speed = cf.readEntry("speed", QString::number(MAX_SPEED));
   
    QString rangle = cf.readEntry ("rangle", QString::number (10.0));
    QString langle = cf.readEntry ("langle", QString::number (10.0));
    QString maxrangle = cf.readEntry ("maxrangle", QString::number (50.0));
    QString maxlangle = cf.readEntry ("maxlangle", QString::number (-50.0));
    QString angleinc = cf.readEntry ("angleinc", QString::number (STEP_ANGLE));
    QString finaltime = cf.readEntry ("finaltime", QString::number (10));

    // Apply values
    speedLineEdit->setText( tr( speed ) );
    angleIncLE->setText( trUtf8( angleinc ) );
    maxLeftLE->setText( trUtf8( maxlangle ) );
    maxRightEL->setText( trUtf8( maxrangle  ) );
    leftEditLine->setText( tr(langle ) );
    rightEditLine->setText( tr( rangle ) );
    periodLineEdit->setText( tr(finaltime) );


    updateRangle();
    updateLangle();
    updateSpeed();
    updatePeriod();

    file->writeStringToFile(" Default values loaded ");
}

void MotorControl::rewind()
{
    shmMotor->rewindMotor();

    double position;
    position = shmMotor->getPosition ();
    file->writeEntryToFile( "Motor position", position);
    file->writeStringToFile(" Motor rewinded ");
}

void MotorControl::periodic()
{
    double final_time = periodLineEdit->text().toDouble();
    double right_angle = rightEditLine->text().toDouble();
    double left_angle = leftEditLine->text().toDouble();
    //double speed = speedLineEdit->text().toDouble();

    if (foreverBox->isChecked () == FALSE )
    {
        cout << "in periodic mode" << endl;
        shmMotor->setPeriodic (final_time,right_angle,left_angle);
        double right = shmMotor->getRangle ();
        double left = shmMotor->getLangle ();
        double position = shmMotor->getPosition();
        file->writeStringToFile(" Start periodic movement with:");
        file->writeEntryToFile(" Final time:", final_time);
        file->writeEntryToFile(" Right angle:", right);
        file->writeEntryToFile(" Left angle:", left);
        file->writeEntryToFile(" Starting motor position:", position);

    }
    else
    {
        cout << " in periodic forever" << endl;
        shmMotor->setForever(right_angle,left_angle);
        double right = shmMotor->getRangle ();
        double left = shmMotor->getLangle ();
        double position = shmMotor->getPosition();
        file->writeEntryToFile(" Right angle:", right);
        file->writeEntryToFile(" Left angle:", left);
        file->writeEntryToFile(" Motor position:", position);
        file->writeStringToFile(" Forever periodic movement ");
    }

}

void MotorControl::incremental()
{
    if ( incModeBox->isChecked() == FALSE)
    {
        cout << "in incremental mode " << endl;
        shmMotor->setIncremental();
        file->writeStringToFile(" Incremental mode ");
    }
    else
    {
        cout << "out of incremental mode " << endl;
        shmMotor->normalMode();
        file->writeStringToFile("Out of incremental mode ");
    }
}

void MotorControl::close()
{
    motorStop();
    shmMotor->normalMode();
    //qApp->quit();
    //accept();
    done (0);
}

void MotorControl::updateRev()
{
    double speed = speedLineEdit->text().toDouble();
    double time_rev = 360.0/speed;
    QString s = QString::number(time_rev);
    timeRevlineEdit->setText( tr( s ) );
}

void MotorControl::saveDef()
{
    cout << __PRETTY_FUNCTION__ << endl;
    CConfigFile cf ("motor.cfg");

    cf.open();

    // Read file
    cf.setGroup ("General");
    double V = speedLineEdit->text().toDouble();
    double left_angle = leftEditLine->text().toDouble();
    double right_angle = rightEditLine->text().toDouble();
    double max_left_angle = maxLeftLE->text().toDouble();
    double max_right_angle = maxRightEL->text().toDouble();
    double angle_inc = angleIncLE->text().toDouble();
    double final_time = periodLineEdit->text().toDouble();

    cf.writeEntry("speed", V);
    cf.writeEntry("rangle", right_angle);
    cf.writeEntry("langle", left_angle);
    cf.writeEntry("maxrangle", max_right_angle);
    cf.writeEntry("maxlangle", max_left_angle);
    cf.writeEntry("angleinc", angle_inc);
    cf.writeEntry("finaltime", final_time);

    cf.write();
    cf.close();

    file->writeStringToFile(" Save default values ");
}

void MotorControl::accelerate()
{
    double accel = accelLE->text().toDouble();
    double timeAccel = timeAccelLE->text().toDouble();
    file->writeEntryToFile("Acceleration (º/s2)",accel);
    file->writeEntryToFile("Acceleration time (ms)",timeAccel);

    if ( rightBox->isChecked() == TRUE)
    {
        int right = 1;
        shmMotor->accelerate(accel,timeAccel,right);
        file->writeStringToFile("Right acceleration mode");
    }
    if ( leftBox->isChecked() == TRUE)
    {
        int left = 2;
        shmMotor->accelerate(accel,timeAccel,left);
        file->writeStringToFile("Left acceleration mode");
    }
    cout << " In acceleration mode " << endl;
}

