/***************************************************************************
 *   Copyright (C) 2007 by GNB	(Grupo Computacion Biologica), EPS (Madrid)*
 *   Carlos Muñiz Solaz							   * 
 *   carlos.muniz@uam.es   						   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/****************************************************************************
** Form interface generated from reading ui file 'motorcontrol.ui'
**
** Created: lun jul 17 16:40:21 2006
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.1.2   edited Dec 19 11:45 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#ifndef MOTORCONTROL_H
#define MOTORCONTROL_H

#include <qvariant.h>
#include <qdialog.h>
#include "ShmMotor.h"
#include "LogFile.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QPushButton;
class QSlider;
class QLabel;
class QLineEdit;
class QTimer;
class QDoubleValidator;
class QErrorMessage;
class FloatSpinBox;
class QFile;
class QButtonGroup;
class QCheckBox;
class LogFile;
class QDateTime;


class MotorControl : public QDialog
{
    Q_OBJECT

public:
    MotorControl( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~MotorControl();

    bool init();

private:

    QButtonGroup* settingsBG;
    QLabel* incModeLabel;
    QCheckBox* incModeBox;
    QLineEdit* timeRevlineEdit;
    QLineEdit* maxRightEL;
    QLineEdit* maxLeftLE;
    QLabel* maxRangleLabel;
    QLabel* maxLangleLabel;
    QLabel* speedLabel;
    QLabel* rightAngleLabel;
    QLabel* leftAngleLabel;
    QLabel* angleIncrementLabel;
    QLabel* trLabel;
    QLineEdit* speedLineEdit;
    QLineEdit* rightEditLine;
    QLineEdit* leftEditLine;
    QLineEdit* angleIncLE;
    QButtonGroup* extraSettingBG;
    QPushButton* loadDefButton;
    QPushButton* saveDefButton;
    QPushButton* loadScripButton;
    QButtonGroup* periodicBG;
    QLabel* timeLabel;
    QLineEdit* periodLineEdit;
    QPushButton* periodicButton;
    QLabel* foreverLabel;
    QCheckBox* foreverBox;
    QPushButton* leftButton;
    QPushButton* rightButton;
    QPushButton* stopButton;
    QLabel* currPosLabel;
    QLineEdit* currPosLineEdit;
    QPushButton* rewindButton;
    QPushButton* calibrateButton;
    QPushButton* closeButton;
    QErrorMessage* ErrorMessage;
    QDateTime* date;
    QTimer *timer;
    QTimer *timer1;
    LogFile* file;
    LogFile* file1;
    QButtonGroup* accelBG;
    QPushButton* accelButton;
    QLineEdit* accelLE;
    QLabel* accelLabel;
    QLineEdit* timeAccelLE;
    QLabel* timeAccelLabel;
    QCheckBox* rightBox;
    QCheckBox* leftBox;
    QLabel* rightLabel;
    QLabel* leftLabel;
    QLineEdit* currSpeedLineEdit;
    //void logFile(char*);
    ShmMotor *shmMotor;


protected:



protected slots:
    virtual void languageChange();
    virtual void updateSpeed ();
    virtual void updateRangle ();
    virtual void updateLangle ();
    virtual void updatePeriod ();
    virtual void updateAspeed();
    virtual void motorCalibrate ();
    virtual void moveRight ();
    virtual void moveLeft ();
    virtual void updatePosition ();
    virtual void motorStop();
    virtual bool validateRight ();
    virtual bool validateLeft ();
    virtual bool validateSpeed ();
    virtual void loadDefaults();
    virtual void rewind();
    virtual void periodic();
    virtual void incremental();
    virtual void close();
    virtual void updateRev();
    virtual void saveDef();
    virtual void updateAccel();
    virtual void updateTime_accel();
    virtual void accelerate();
};

#endif // MOTORCONTROL_H
