/***************************************************************************
 *   Copyright (C) 2007 by GNB	(Grupo Computacion Biologica), EPS (Madrid)*
 *   Carlos Muñiz Solaz							   * 
 *   carlos.muniz@uam.es   						   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef __MOTOR_H__
#define __MOTOR_H__

//!< Modules Include and definitions
#define __KERNEL__
#define MODULE

#include <linux/init.h>
#include <linux/signal.h>
#include <linux/unistd.h>
#include <linux/module.h>
#include <asm/io.h>

//!< RTAI Include
#include <rtai.h>
#include <rtai_sched.h>
#include <rtai_shm.h>
#include <rtai_nam2num.h>

//!< Comedi and ComediLib Include
#include <linux/comedi.h>
#include <linux/comedilib.h>

//!< General System include
#include <math.h>
#include <asm/string.h>

#include "../include/motor_shm.h"


double my_round(double);
void change_speed(void);
void move_left(void);
void move_right(void);
void reset_motor(void);
void zeroing(void);
void set_periodic(void);
void set_inc_mode(void);
void accelerate(void);

int motor_init(void);
void motor_exit(void);
int init_rt_thread(void);
void cleanup_rt_thread(void);
void RTtask(int t);
double calculatePeriod (double speed);
double calculateAperiod(double acceleration);
void cleanup_comedi(void);
int init_comedi(void);
int init_shmem ( void );
void init_motor (MOTOR_SHM * motor_shm);
void cleanup_shmem(void);

#endif
